import { defineComponent as i, computed as f, ref as h, onMounted as S, nextTick as q, toRefs as X, watch as R, getCurrentInstance as z } from "vue";
const Q = {
  // data
  dataSource: {
    type: String,
    default: "server"
  },
  url: {
    type: String,
    default: null
  },
  items: {
    type: Array,
    default: () => []
  },
  // pagination
  pagination: {
    type: Boolean,
    default: !0
  },
  rowsPerPageCount: {
    type: Number,
    default: 10
  },
  rowsPerPageOptions: {
    type: Array,
    default: () => [5, 10, 25, 50, 100]
  },
  // search
  searching: {
    type: Boolean,
    default: !0
  },
  // order
  orderBy: {
    type: String,
    required: !1,
    default: null
  },
  orderDirection: {
    type: String,
    default: "asc"
  },
  // row-selection
  rowSelection: {
    type: Boolean,
    default: !1
  },
  // actions
  actions: {
    type: Boolean,
    default: !1
  },
  // numbering
  numbering: {
    type: Boolean,
    default: !1
  },
  // scrollX
  scrollX: {
    type: Boolean,
    default: !1
  },
  // fixed columns
  fixedColumnsStart: {
    type: Number,
    required: !1,
    default: 0
  },
  fixedColumnsEnd: {
    type: Number,
    required: !1,
    default: 0
  }
}, J = (n) => {
  if (!n.rowsPerPageOptions.includes(n.rowsPerPageCount))
    throw new Error("Prop rowsPerPageCount is not present in prop rowsPerPageOptions");
};
function T(n, e, r = !1) {
  let t = null;
  return function(...s) {
    const o = this, l = () => {
      t = null, r || n.apply(o, s);
    }, a = r && !t;
    t && clearTimeout(t), t = setTimeout(l, e), a && n.apply(o, s);
  };
}
const K = /* @__PURE__ */ i({
  __name: "TableContent",
  props: {
    scrollX: {
      type: Boolean,
      required: !0
    }
  },
  setup(n) {
    const e = n, r = f(() => ({
      "scroll-x": e.scrollX
    }));
    return { __sfc: !0, props: e, tableContentClassObject: r };
  }
});
function d(n, e, r, t, s, o, l, a) {
  var c = typeof n == "function" ? n.options : n;
  return e && (c.render = e, c.staticRenderFns = r, c._compiled = !0), {
    exports: n,
    options: c
  };
}
var Y = function() {
  var e = this, r = e._self._c, t = e._self._setupProxy;
  return r("div", { staticClass: "dt-content", class: t.tableContentClassObject }, [r("table", { staticClass: "dt-element-table" }, [e._t("default")], 2)]);
}, ee = [], te = /* @__PURE__ */ d(
  K,
  Y,
  ee
);
const re = te.exports, ne = /* @__PURE__ */ i({
  __name: "TableBody",
  setup(n) {
    return { __sfc: !0 };
  }
});
var se = function() {
  var e = this, r = e._self._c;
  return e._self._setupProxy, r("tbody", { staticClass: "dt-body" }, [e._t("default")], 2);
}, oe = [], le = /* @__PURE__ */ d(
  ne,
  se,
  oe
);
const ae = le.exports, $ = (n, e, r, t = !1) => {
  if (!r)
    return;
  const s = Array.from(n.getElementsByTagName(e)), o = t ? s.slice(-r).reverse() : s.slice(0, r), l = t ? "right" : "left";
  o.reduce((a, c) => {
    const u = c;
    return u.style.position = "sticky", u.style[l] = `${a}px`, a + u.offsetWidth + 1;
  }, 0);
}, ce = (n) => n.replace(/&amp;/gi, "&").replace(/&lt;/gi, "<").replace(/&gt;/gi, ">").replace(/&#39;/gi, "'").replace(/&quot;/gi, '"').replace(/&nbsp;/gi, " ").replace(/&copy;/gi, "©").replace(/&reg;/gi, "®").replace(/&trade;/gi, "™").replace(/&hellip;/gi, "…").replace(/&euro;/gi, "€").replace(/&pound;/gi, "£").replace(/&yen;/gi, "¥").replace(/&cent;/gi, "¢").replace(/&sect;/gi, "§").replace(/&deg;/gi, "°").replace(/&middot;/gi, "·").replace(/&ndash;/gi, "–").replace(/&mdash;/gi, "—").replace(/&bull;/gi, "•").replace(/&para;/gi, "¶").replace(/&permil;/gi, "‰"), ue = i({
  name: "DtCell",
  props: {
    template: {
      type: Function,
      required: !1,
      default: null
    },
    row: {
      type: Object,
      required: !1,
      default: null
    }
  },
  render(n) {
    return n("td", { class: "dt-cell" }, this.template({ row: this.row }));
  }
}), ie = null, de = null;
var pe = /* @__PURE__ */ d(
  ue,
  ie,
  de
);
const _e = pe.exports, fe = /* @__PURE__ */ i({
  __name: "TableCell",
  props: {
    column: {
      type: Object,
      required: !0
    },
    row: {
      type: Object,
      required: !0
    }
  },
  setup(n) {
    const e = n, r = f(() => {
      const t = e.row.item[e.column.params.field] ?? "";
      return typeof t == "string" ? ce(t) : t;
    });
    return { __sfc: !0, props: e, value: r, TableCellSlot: _e };
  }
});
var ve = function() {
  var e = this, r = e._self._c, t = e._self._setupProxy;
  return t.props.column.slots.cell ? r(t.TableCellSlot, { attrs: { row: t.props.row, template: t.props.column.slots.cell } }) : r("td", { key: t.props.column.index, staticClass: "dt-cell", class: t.props.column.appearance.classObject }, [e._v(" " + e._s(t.value) + " ")]);
}, me = [], he = /* @__PURE__ */ d(
  fe,
  ve,
  me
);
const ge = he.exports, Ce = /* @__PURE__ */ i({
  __name: "TableCellActions",
  setup(n) {
    return { __sfc: !0 };
  }
});
var we = function() {
  var e = this, r = e._self._c;
  return e._self._setupProxy, r("td", { staticClass: "dt-cell-actions" }, [r("div", { staticClass: "dt-cell-actions-inner" }, [e._t("default")], 2)]);
}, be = [], ye = /* @__PURE__ */ d(
  Ce,
  we,
  be
);
const xe = ye.exports, Pe = /* @__PURE__ */ i({
  __name: "TableCellNumbering",
  props: {
    number: {
      type: Number,
      required: !0
    }
  },
  setup(n) {
    return { __sfc: !0, props: n };
  }
});
var $e = function() {
  var e = this, r = e._self._c, t = e._self._setupProxy;
  return r("td", { staticClass: "dt-cell-numbering" }, [r("div", { staticClass: "dt-cell-numbering-inner" }, [e._v(e._s(t.props.number))])]);
}, Se = [], ke = /* @__PURE__ */ d(
  Pe,
  $e,
  Se
);
const Re = ke.exports, Te = /* @__PURE__ */ i({
  __name: "TableCellSelection",
  props: {
    index: {
      type: Number,
      required: !0
    },
    checked: {
      type: Boolean,
      required: !0
    }
  },
  emits: ["select-row", "deselect-row"],
  setup(n, { emit: e }) {
    return { __sfc: !0, props: n, emit: e, handleSelectRowClick: (s, o) => {
      s.target instanceof HTMLInputElement && (s.target.checked ? e("select-row", o) : e("deselect-row", o));
    } };
  }
});
var Ie = function() {
  var e = this, r = e._self._c, t = e._self._setupProxy;
  return r("td", { staticClass: "dt-cell-selection" }, [r("div", { staticClass: "dt-cell-selection-inner" }, [r("input", { attrs: { type: "checkbox" }, domProps: { checked: t.props.checked }, on: { change: (s) => t.handleSelectRowClick(s, t.props.index) } })])]);
}, qe = [], Ae = /* @__PURE__ */ d(
  Te,
  Ie,
  qe
);
const Le = Ae.exports, Oe = /* @__PURE__ */ i({
  __name: "TableRow",
  props: {
    row: {
      type: Object,
      required: !0
    },
    columns: {
      type: Array,
      required: !0
    },
    selectedRowIndexes: {
      type: Array,
      required: !0
    },
    rowSelection: {
      type: Boolean,
      required: !0
    },
    actions: {
      type: Boolean,
      required: !0
    },
    numbering: {
      type: Boolean,
      required: !0
    },
    fixedColumnsStart: {
      type: Number,
      required: !0
    },
    fixedColumnsEnd: {
      type: Number,
      required: !0
    }
  },
  emits: ["select-row", "deselect-row"],
  setup(n, { emit: e }) {
    const r = n, t = h(null), s = f(() => r.selectedRowIndexes.includes(r.row.index)), o = (c) => {
      e("select-row", c);
    }, l = (c) => {
      e("deselect-row", c);
    }, a = () => {
      q(() => {
        t.value && ($(t.value, "td", r.fixedColumnsStart), $(t.value, "td", r.fixedColumnsEnd, !0));
      });
    };
    return S(a), { __sfc: !0, props: r, emit: e, rowElement: t, isChecked: s, handleSelectRow: o, handleDeselectRow: l, initFixedColumns: a, TableCell: ge, TableCellActions: xe, TableCellNumbering: Re, TableCellSelection: Le };
  }
});
var Fe = function() {
  var e = this, r = e._self._c, t = e._self._setupProxy;
  return r("tr", { key: t.props.row.index, ref: "rowElement" }, [t.props.numbering ? r(t.TableCellNumbering, { attrs: { number: t.props.row.number } }) : e._e(), t.props.rowSelection ? r(t.TableCellSelection, { attrs: { checked: t.isChecked, index: t.props.row.index }, on: { "deselect-row": t.handleDeselectRow, "select-row": t.handleSelectRow } }) : e._e(), e._l(t.props.columns, function(s) {
    return r(t.TableCell, { key: `${e.row.index}${s.index}`, attrs: { column: s, row: t.props.row } });
  }), t.props.actions ? r(t.TableCellActions, [e._t("actions")], 2) : e._e()], 2);
}, Be = [], Me = /* @__PURE__ */ d(
  Oe,
  Fe,
  Be
);
const Ee = Me.exports, De = `<svg viewBox="0 0 14 14" fill="none" xmlns="http://www.w3.org/2000/svg">
    <path
            d="M3.63435 0.19871C3.57113 0.135484 3.49887 0.0903226 3.41758 0.0541935C3.255 -0.0180645 3.06532 -0.0180645 2.90274 0.0541935C2.82145 0.0903226 2.74919 0.135484 2.68597 0.19871L0.427901 2.45677C0.165965 2.71871 0.165965 3.15226 0.427901 3.41419C0.689836 3.67613 1.12338 3.67613 1.38532 3.41419L2.48726 2.31226V13.3226C2.48726 13.6929 2.79435 14 3.16467 14C3.535 14 3.84209 13.6929 3.84209 13.3226V2.31226L4.94403 3.41419C5.07951 3.54968 5.25113 3.6129 5.42274 3.6129C5.59435 3.6129 5.76597 3.54968 5.90145 3.41419C6.16338 3.15226 6.16338 2.71871 5.90145 2.45677L3.64338 0.19871H3.63435ZM13.7685 13.3226C13.7685 12.9523 13.4615 12.6452 13.0911 12.6452H7.22016C6.84984 12.6452 6.54274 12.9523 6.54274 13.3226C6.54274 13.6929 6.84984 14 7.22016 14H13.0911C13.4615 14 13.7685 13.6929 13.7685 13.3226ZM7.22016 8.58064C6.84984 8.58064 6.54274 8.27355 6.54274 7.90323C6.54274 7.5329 6.84984 7.22581 7.22016 7.22581H9.47823C9.84855 7.22581 10.1556 7.5329 10.1556 7.90323C10.1556 8.27355 9.84855 8.58064 9.47823 8.58064H7.22016ZM7.22016 5.87097H7.67177C8.0421 5.87097 8.34919 5.56387 8.34919 5.19355C8.34919 4.82323 8.0421 4.51613 7.67177 4.51613H7.22016C6.84984 4.51613 6.54274 4.82323 6.54274 5.19355C6.54274 5.56387 6.84984 5.87097 7.22016 5.87097ZM11.2847 11.2903H7.22016C6.84984 11.2903 6.54274 10.9832 6.54274 10.6129C6.54274 10.2426 6.84984 9.93548 7.22016 9.93548H11.2847C11.655 9.93548 11.9621 10.2426 11.9621 10.6129C11.9621 10.9832 11.655 11.2903 11.2847 11.2903Z"
            fill="currentColor"></path>
</svg>
`, je = `<svg viewBox="0 0 14 14" fill="none" xmlns="http://www.w3.org/2000/svg">
    <path
        d="M5.64515 3.61291C5.47353 3.61291 5.30192 3.54968 5.16644 3.4142L3.38708 1.63484L1.60773 3.4142C1.34579 3.67613 0.912244 3.67613 0.650309 3.4142C0.388374 3.15226 0.388374 2.71871 0.650309 2.45678L2.90837 0.198712C3.17031 -0.0632236 3.60386 -0.0632236 3.86579 0.198712L6.12386 2.45678C6.38579 2.71871 6.38579 3.15226 6.12386 3.4142C5.98837 3.54968 5.81676 3.61291 5.64515 3.61291Z"
        fill="currentColor"></path>
    <path
        d="M3.38714 14C3.01681 14 2.70972 13.6929 2.70972 13.3226V0.677419C2.70972 0.307097 3.01681 0 3.38714 0C3.75746 0 4.06456 0.307097 4.06456 0.677419V13.3226C4.06456 13.6929 3.75746 14 3.38714 14Z"
        fill="currentColor"></path>
    <path
        d="M10.6129 14C10.4413 14 10.2697 13.9368 10.1342 13.8013L7.87611 11.5432C7.61418 11.2813 7.61418 10.8477 7.87611 10.5858C8.13805 10.3239 8.5716 10.3239 8.83353 10.5858L10.6129 12.3652L12.3922 10.5858C12.6542 10.3239 13.0877 10.3239 13.3497 10.5858C13.6116 10.8477 13.6116 11.2813 13.3497 11.5432L11.0916 13.8013C10.9561 13.9368 10.7845 14 10.6129 14Z"
        fill="currentColor"></path>
    <path
        d="M10.6129 14C10.2426 14 9.93552 13.6929 9.93552 13.3226V0.677419C9.93552 0.307097 10.2426 0 10.6129 0C10.9833 0 11.2904 0.307097 11.2904 0.677419V13.3226C11.2904 13.6929 10.9832 14 10.6129 14Z"
        fill="currentColor"></path>
</svg>
`, Ne = `<svg viewBox="0 0 14 14" fill="none" xmlns="http://www.w3.org/2000/svg">
    <path
        d="M4.93953 10.5858L3.83759 11.6877V0.677419C3.83759 0.307097 3.53049 0 3.16017 0C2.78985 0 2.48275 0.307097 2.48275 0.677419V11.6877L1.38082 10.5858C1.11888 10.3239 0.685331 10.3239 0.423396 10.5858C0.16146 10.8477 0.16146 11.2813 0.423396 11.5432L2.68146 13.8013C2.74469 13.8645 2.81694 13.9097 2.89823 13.9458C2.97952 13.9819 3.06985 14 3.16017 14C3.25049 14 3.33178 13.9819 3.42211 13.9458C3.5034 13.9097 3.57565 13.8645 3.63888 13.8013L5.89694 11.5432C6.15888 11.2813 6.15888 10.8477 5.89694 10.5858C5.63501 10.3239 5.20146 10.3239 4.93953 10.5858ZM13.0957 0H7.22468C6.85436 0 6.54726 0.307097 6.54726 0.677419C6.54726 1.04774 6.85436 1.35484 7.22468 1.35484H13.0957C13.466 1.35484 13.7731 1.04774 13.7731 0.677419C13.7731 0.307097 13.466 0 13.0957 0ZM7.22468 5.41935H9.48275C9.85307 5.41935 10.1602 5.72645 10.1602 6.09677C10.1602 6.4671 9.85307 6.77419 9.48275 6.77419H7.22468C6.85436 6.77419 6.54726 6.4671 6.54726 6.09677C6.54726 5.72645 6.85436 5.41935 7.22468 5.41935ZM7.6763 8.12903H7.22468C6.85436 8.12903 6.54726 8.43613 6.54726 8.80645C6.54726 9.17677 6.85436 9.48387 7.22468 9.48387H7.6763C8.04662 9.48387 8.35372 9.17677 8.35372 8.80645C8.35372 8.43613 8.04662 8.12903 7.6763 8.12903ZM7.22468 2.70968H11.2892C11.6595 2.70968 11.9666 3.01677 11.9666 3.3871C11.9666 3.75742 11.6595 4.06452 11.2892 4.06452H7.22468C6.85436 4.06452 6.54726 3.75742 6.54726 3.3871C6.54726 3.01677 6.85436 2.70968 7.22468 2.70968Z"
        fill="currentColor"></path>
</svg>
`, He = /* @__PURE__ */ i({
  __name: "TableColumn",
  props: {
    column: {
      type: Object,
      required: !0
    },
    order: {
      type: Object,
      required: !1,
      default: null
    }
  },
  emits: ["update:order"],
  setup(n, { emit: e }) {
    const r = n, t = f(() => r.column.params.orderable), s = f(() => ({
      "dt-orderable": t.value,
      ...r.column.appearance.classObject
    })), o = f(() => !r.order || r.order.column !== r.column.params.field ? je : r.order.direction === "asc" ? Ne : De);
    return { __sfc: !0, props: r, emit: e, columnOrderEnable: t, classObject: s, orderIcon: o, handleOrderUpdate: () => {
      if (!t.value)
        return;
      let a;
      !r.order || r.order.column !== r.column.params.field || r.order.direction === "desc" ? a = "asc" : a = "desc";
      const c = {
        direction: a,
        column: r.column.params.field
      };
      e("update:order", c);
    } };
  }
});
var Ge = function() {
  var e = this, r = e._self._c, t = e._self._setupProxy;
  return r("th", { staticClass: "dt-column", class: t.classObject, style: t.props.column.appearance.styleObject, on: { click: t.handleOrderUpdate } }, [r("div", { staticClass: "dt-column-inner" }, [r("span", [e._v(e._s(t.props.column.params.title))]), t.columnOrderEnable ? r("div", [r("div", { staticClass: "dt-order-column-btn", domProps: { innerHTML: e._s(t.orderIcon) } })]) : e._e()])]);
}, Ze = [], Ue = /* @__PURE__ */ d(
  He,
  Ge,
  Ze
);
const Ve = Ue.exports, We = /* @__PURE__ */ i({
  __name: "TableColumnActions",
  setup(n) {
    return { __sfc: !0 };
  }
});
var Xe = function() {
  var e = this, r = e._self._c;
  return e._self._setupProxy, r("th", { staticClass: "dt-column dt-column--actions" });
}, ze = [], Qe = /* @__PURE__ */ d(
  We,
  Xe,
  ze
);
const Je = Qe.exports, Ke = /* @__PURE__ */ i({
  __name: "TableColumnNumbering",
  setup(n) {
    return { __sfc: !0 };
  }
});
var Ye = function() {
  var e = this;
  return e._self._c, e._self._setupProxy, e._m(0);
}, et = [function() {
  var n = this, e = n._self._c;
  return n._self._setupProxy, e("th", { staticClass: "dt-column dt-column-numbering" }, [e("div", { staticClass: "dt-column-numbering-inner" }, [n._v("#")])]);
}], tt = /* @__PURE__ */ d(
  Ke,
  Ye,
  et
);
const rt = tt.exports, nt = /* @__PURE__ */ i({
  __name: "TableColumnSelection",
  props: {
    isSelectedAll: {
      type: Boolean,
      required: !0
    }
  },
  emits: ["select-all", "deselect-all"],
  setup(n, { emit: e }) {
    return { __sfc: !0, props: n, emit: e, handleSelectAllClick: (s) => {
      s.target instanceof HTMLInputElement && (s.target.checked ? e("select-all") : e("deselect-all"));
    } };
  }
});
var st = function() {
  var e = this, r = e._self._c, t = e._self._setupProxy;
  return r("th", { staticClass: "dt-column dt-column-selection" }, [r("div", { staticClass: "dt-column-selection-inner" }, [r("input", { attrs: { type: "checkbox" }, domProps: { checked: t.props.isSelectedAll }, on: { change: t.handleSelectAllClick } })])]);
}, ot = [], lt = /* @__PURE__ */ d(
  nt,
  st,
  ot
);
const at = lt.exports, ct = /* @__PURE__ */ i({
  __name: "TableHead",
  props: {
    columns: {
      type: Array,
      required: !0
    },
    order: {
      type: Object,
      required: !1,
      default: null
    },
    isSelectedAll: {
      type: Boolean,
      required: !0
    },
    rowSelection: {
      type: Boolean,
      required: !0
    },
    actions: {
      type: Boolean,
      required: !0
    },
    numbering: {
      type: Boolean,
      required: !0
    },
    fixedColumnsStart: {
      type: Number,
      required: !0
    },
    fixedColumnsEnd: {
      type: Number,
      required: !0
    }
  },
  emits: ["update:order", "select-all", "deselect-all"],
  setup(n, { emit: e }) {
    const r = n, t = h(null), s = (c) => {
      e("update:order", c);
    }, o = () => {
      e("select-all");
    }, l = () => {
      e("deselect-all");
    }, a = () => {
      q(() => {
        t.value && ($(t.value, "th", r.fixedColumnsStart), $(t.value, "th", r.fixedColumnsEnd, !0));
      });
    };
    return S(a), { __sfc: !0, props: r, emit: e, rowElement: t, handleOrderUpdate: s, handleSelectAll: o, handleDeselectAll: l, initFixedColumns: a, TableColumn: Ve, TableColumnActions: Je, TableColumnNumbering: rt, TableColumnSelection: at };
  }
});
var ut = function() {
  var e = this, r = e._self._c, t = e._self._setupProxy;
  return r("thead", { staticClass: "dt-head" }, [r("tr", { ref: "rowElement" }, [t.props.numbering ? r(t.TableColumnNumbering) : e._e(), r(t.TableColumnSelection, { attrs: { "is-selected-all": t.props.isSelectedAll }, on: { "deselect-all": t.handleDeselectAll, "select-all": t.handleSelectAll } }), e._l(t.props.columns, function(s) {
    return r(t.TableColumn, { key: s.index, attrs: { column: s, order: t.props.order }, on: { "update:order": t.handleOrderUpdate } });
  }), t.props.actions ? r(t.TableColumnActions) : e._e()], 2)]);
}, it = [], dt = /* @__PURE__ */ d(
  ct,
  ut,
  it
);
const pt = dt.exports, _t = /* @__PURE__ */ i({
  __name: "TableFooter",
  setup(n) {
    return { __sfc: !0 };
  }
});
var ft = function() {
  var e = this, r = e._self._c;
  return e._self._setupProxy, r("div", { staticClass: "dt-footer" }, [r("div", { staticClass: "dt-footer-left" }, [e._t("footerLeft")], 2), r("div", [e._t("footerRight")], 2)]);
}, vt = [], mt = /* @__PURE__ */ d(
  _t,
  ft,
  vt
);
const ht = mt.exports, gt = /* @__PURE__ */ i({
  __name: "PageDetails",
  props: {
    total: {
      type: Number,
      required: !0
    },
    filtered: {
      type: Number,
      required: !0
    },
    page: {
      type: Number,
      required: !0
    },
    rowsPerPage: {
      type: Number,
      required: !0
    },
    countItems: {
      type: Number,
      required: !0
    }
  },
  setup(n) {
    const e = n, r = f(() => e.countItems ? (e.page - 1) * e.rowsPerPage + 1 : 0), t = f(() => (e.page - 1) * e.rowsPerPage + e.countItems);
    function s(a, c, u, _) {
      const m = Math.abs(a) % 100, v = m % 10;
      return m > 10 && m < 20 ? _ : v > 1 && v < 5 ? u : v === 1 ? c : _;
    }
    const o = f(() => s(e.filtered, "записи", "записей", "записей")), l = f(() => s(e.total, "записи", "записей", "записей"));
    return { __sfc: !0, props: e, numberStart: r, numberEnd: t, declension: s, filteredRecords: o, totalRecords: l };
  }
});
var Ct = function() {
  var e = this, r = e._self._c, t = e._self._setupProxy;
  return r("div", { staticClass: "dt-page-details" }, [r("span", [e._v(" Записи с " + e._s(t.numberStart) + " до " + e._s(t.numberEnd) + " из " + e._s(t.props.filtered) + " " + e._s(t.filteredRecords))]), t.props.total !== t.props.filtered ? r("span", [e._v(" (из " + e._s(t.props.total) + " " + e._s(t.totalRecords) + ") ")]) : e._e()]);
}, wt = [], bt = /* @__PURE__ */ d(
  gt,
  Ct,
  wt
);
const yt = bt.exports, xt = `<svg viewBox="0 0 8 8" xmlns="http://www.w3.org/2000/svg" fill="none" stroke="currentColor" stroke-width="1" stroke-linecap="round" stroke-linejoin="round">
    <path d="M4 1l-3 3 3 3" />
    <path d="M7 1l-3 3 3 3" />
</svg>
`, Pt = `<svg viewBox="0 0 8 8" xmlns="http://www.w3.org/2000/svg" fill="none" stroke="currentColor" stroke-width="1" stroke-linecap="round" stroke-linejoin="round">
    <path d="M1.0 1l3 3-3 3" />
    <path d="M4.0 1l3 3-3 3" />
</svg>
`, $t = `<svg viewBox="0 0 8 8" xmlns="http://www.w3.org/2000/svg" fill="none" stroke="currentColor" stroke-width="1" stroke-linecap="round" stroke-linejoin="round">
    <path d="M5 1l-3 3 3 3" />
</svg>
`, St = `<svg viewBox="0 0 8 8" xmlns="http://www.w3.org/2000/svg" fill="none" stroke="currentColor" stroke-width="1" stroke-linecap="round" stroke-linejoin="round">
    <path d="M3 1l3 3-3 3" />
</svg>
`, kt = /* @__PURE__ */ i({
  __name: "TablePagination",
  props: {
    page: {
      type: Number,
      required: !0
    },
    filtered: {
      type: Number,
      required: !0
    },
    rowsPerPage: {
      type: Number,
      required: !0
    }
  },
  emits: ["input"],
  setup(n, { emit: e }) {
    const r = n, t = f(() => Math.ceil(r.filtered / r.rowsPerPage)), s = f(() => {
      const v = t.value, y = r.page, g = 5;
      if (v <= g)
        return Array.from({ length: v }, (b, x) => x + 1);
      let C = Math.max(1, y - Math.floor(g / 2)), w = C + g - 1;
      return w > v && (w = v, C = w - g + 1), Array.from({ length: g }, (b, x) => C + x);
    }), o = f(() => r.page > 1), l = f(() => r.page < t.value);
    return { __sfc: !0, props: r, emit: e, countPages: t, pages: s, canGoPrev: o, canGoNext: l, handleClickPage: (v) => {
      e("input", v);
    }, handleGoPrev: () => {
      o.value && e("input", r.page - 1);
    }, handleGoFirst: () => {
      o.value && e("input", 1);
    }, handleGoNext: () => {
      l.value && e("input", r.page + 1);
    }, handleGoLast: () => {
      l.value && e("input", t.value);
    }, chevronDoubleLeftIcon: xt, chevronDoubleRightIcon: Pt, chevronLeftIcon: $t, chevronRightIcon: St };
  }
});
var Rt = function() {
  var e = this, r = e._self._c, t = e._self._setupProxy;
  return r("div", { staticClass: "dt-pagination" }, [r("div", { staticClass: "dt-pagination-page dt-pagination-page-arrow", class: { disabled: !t.canGoPrev }, on: { click: t.handleGoFirst } }, [r("div", { domProps: { innerHTML: e._s(t.chevronDoubleLeftIcon) } })]), r("div", { staticClass: "dt-pagination-page dt-pagination-page-arrow", class: { disabled: !t.canGoPrev }, on: { click: t.handleGoPrev } }, [r("div", { domProps: { innerHTML: e._s(t.chevronLeftIcon) } })]), e._l(t.pages, function(s, o) {
    return r("div", { key: o, staticClass: "dt-pagination-page", class: { active: s === t.props.page }, on: { click: function(l) {
      return t.handleClickPage(s);
    } } }, [e._v(" " + e._s(s) + " ")]);
  }), r("div", { staticClass: "dt-pagination-page dt-pagination-page-arrow", class: { disabled: !t.canGoNext }, on: { click: t.handleGoNext } }, [r("div", { domProps: { innerHTML: e._s(t.chevronRightIcon) } })]), r("div", { staticClass: "dt-pagination-page dt-pagination-page-arrow", class: { disabled: !t.canGoNext }, on: { click: t.handleGoLast } }, [r("div", { domProps: { innerHTML: e._s(t.chevronDoubleRightIcon) } })])], 2);
}, Tt = [], It = /* @__PURE__ */ d(
  kt,
  Rt,
  Tt
);
const qt = It.exports, At = /* @__PURE__ */ i({
  __name: "RowsPerPageControl",
  props: {
    value: {
      type: Number,
      required: !0
    },
    rowsPerPageOptions: {
      type: Array,
      required: !0
    }
  },
  emits: ["input"],
  setup(n, { emit: e }) {
    return { __sfc: !0, props: n, emit: e, handleInput: (s) => {
      s.target instanceof HTMLSelectElement && s.target.value && e("input", +s.target.value);
    } };
  }
});
var Lt = function() {
  var e = this, r = e._self._c, t = e._self._setupProxy;
  return r("div", { staticClass: "flex items-center" }, [r("span", [e._v("Показать")]), r("select", { staticClass: "dt-rows-per-page", domProps: { value: t.props.value }, on: { input: t.handleInput } }, e._l(t.props.rowsPerPageOptions, function(s, o) {
    return r("option", { key: o, domProps: { value: s } }, [e._v(" " + e._s(s) + " ")]);
  }), 0)]);
}, Ot = [], Ft = /* @__PURE__ */ d(
  At,
  Lt,
  Ot
);
const Bt = Ft.exports, Mt = /* @__PURE__ */ i({
  __name: "TableTop",
  setup(n) {
    return { __sfc: !0 };
  }
});
var Et = function() {
  var e = this, r = e._self._c;
  return e._self._setupProxy, r("div", { staticClass: "dt-top" }, [r("div", { staticClass: "dt-top-left" }, [e._t("topLeftBeforeActions"), e._t("topSearch"), e._t("topLeftAfterActions")], 2), r("div", [e._t("topRight")], 2)]);
}, Dt = [], jt = /* @__PURE__ */ d(
  Mt,
  Et,
  Dt
);
const Nt = jt.exports, Ht = `<svg viewBox="0 0 8 8" xmlns="http://www.w3.org/2000/svg">
    <path d="M1 1L7 7M1 7L7 1" stroke="currentColor" stroke-width="1" stroke-linecap="round" stroke-linejoin="round"/>
</svg>
`, Gt = `<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 16 16" fill="none" stroke="currentColor" stroke-width="1" stroke-linecap="round" stroke-linejoin="round">
    <circle cx="6.5" cy="6.5" r="5.7"></circle>
    <line x1="15" y1="15" x2="10.5" y2="10.5"></line>
</svg>
`, Zt = /* @__PURE__ */ i({
  __name: "TableSearch",
  props: {
    value: {
      type: String,
      required: !0
    }
  },
  emits: ["input"],
  setup(n, { emit: e }) {
    const r = n, t = h(null), s = h(!1), o = f(() => ({
      active: !!r.value || s.value
    })), l = f(() => !!r.value);
    return { __sfc: !0, props: r, emit: e, inputElement: t, hasFocus: s, searchWrapperClass: o, displayCross: l, handleInput: (m) => {
      m.target instanceof HTMLInputElement && e("input", m.target.value ?? "");
    }, handleClearSearch: () => {
      e("input", "");
    }, handleWrapperClick: () => {
      t.value && t.value.focus();
    }, handleFocus: (m) => {
      s.value = m;
    }, crossIcon: Ht, searchIcon: Gt };
  }
});
var Ut = function() {
  var e = this, r = e._self._c, t = e._self._setupProxy;
  return r("div", { staticClass: "dt-search", class: t.searchWrapperClass, on: { click: t.handleWrapperClick } }, [r("input", { ref: "inputElement", staticClass: "dt-search-input", attrs: { placeholder: "Введите для поиска", type: "text" }, domProps: { value: e.value }, on: { blur: function(s) {
    return t.handleFocus(!1);
  }, focus: function(s) {
    return t.handleFocus(!0);
  }, input: t.handleInput } }), r("div", { staticClass: "dt-search-icon" }, [r("div", { domProps: { innerHTML: e._s(t.searchIcon) } })]), r("div", { staticClass: "dt-search-label" }, [e._v("Поиск")]), t.displayCross ? r("div", { staticClass: "dt-cross-icon", on: { click: t.handleClearSearch } }, [r("div", { domProps: { innerHTML: e._s(t.crossIcon) } })]) : e._e()]);
}, Vt = [], Wt = /* @__PURE__ */ d(
  Zt,
  Ut,
  Vt
);
const Xt = Wt.exports;
function zt(n, e, r) {
  return !e || !r.length ? n : n.filter((t) => r.reduce((s, o) => t[o] ? s || `${t[o]}`.toLowerCase().includes(e.toLowerCase()) : !1, !1));
}
function Qt(n, e, r) {
  if (e < 1 || r < 1) return [];
  const t = (e - 1) * r, s = t + r;
  return n.slice(t, s);
}
const Jt = (n, e, r) => n.sort((t, s) => {
  const o = t[e], l = s[e];
  return o === null ? 1 : l === null ? -1 : o === l ? 0 : r === "asc" ? o > l ? 1 : -1 : o < l ? 1 : -1;
}), Kt = () => ({
  processItems: (e, r, t) => {
    const s = e.value.length;
    let o = e.value;
    if (t.searching.value) {
      const u = r.value.filter((_) => _.params.searchable).map((_) => _.params.field);
      o = zt(e.value, t.search.value, u);
    }
    const l = o.length;
    t.order.value && (o = Jt(
      o,
      t.order.value.column,
      t.order.value.direction
    )), t.pagination.value && (o = Qt(
      o,
      t.page.value,
      t.rowsPerPage.value
    ));
    let a = 0;
    t.pagination.value && (a = (t.page.value - 1) * t.rowsPerPage.value);
    const c = o.map((u, _) => ({
      index: _,
      item: u,
      number: _ + 1 + a
    }));
    return {
      total: s,
      filtered: l,
      rows: c
    };
  }
}), Yt = (n, e) => e ? `start=${(n - 1) * e}&length=${e}` : "start=1", er = (n) => {
  let e = "search[regex]=false";
  return e += "&search[value]=", n && (e += encodeURIComponent(n)), e;
}, tr = (n, e) => {
  if (!n)
    return "";
  const r = e.find((t) => t.params.field === n.column);
  return r ? `order[0][column]=${r.index}&order[0][dir]=${n.direction}` : "";
}, rr = (n) => n.reduce((e, r) => {
  let t = "";
  t += `columns[${r.index}][data]=${r.params.field}`, t += `&columns[${r.index}][name]=${r.params.field}`, t += `&columns[${r.index}][searchable]=true`, t += `&columns[${r.index}][orderable]=${r.params.orderable}`, t += `&columns[${r.index}][searchable]=${r.params.searchable}`, t += `&columns[${r.index}][search][value]=`, t += `&columns[${r.index}][search][regex]=false`;
  let s = e;
  return s && (s += "&"), s += t, s;
}, ""), nr = (n) => {
  const e = Yt(n.page, n.rowsPerPage), r = rr(n.columns), t = er(n.search), s = tr(n.order, n.columns);
  return `${r}&${s}&${e}&${t}&`;
}, sr = () => ({
  fetchRemoteItems: async (e, r, t) => {
    if (!e.value)
      throw new Error("Prop url is not defined");
    const s = nr({
      page: t.page.value,
      rowsPerPage: t.pagination.value ? t.rowsPerPage.value : null,
      columns: r.value,
      search: t.search.value,
      order: t.order.value
    }), l = await (await fetch(`${e.value}?${s}`)).json();
    let a = 0;
    return t.pagination.value && (a = (t.page.value - 1) * t.rowsPerPage.value), {
      rows: l.data.map((u, _) => ({
        index: _,
        item: u,
        number: _ + 1 + a
      })),
      total: l.recordsTotal,
      filtered: l.recordsFiltered
    };
  }
}), or = (n, e, r, t, s) => {
  const o = h(null), { processItems: l } = Kt(), { fetchRemoteItems: a } = sr();
  return {
    tableData: o,
    fetchTableData: async () => {
      switch (n.value) {
        case "client":
          o.value = l(r, t, s);
          break;
        case "server":
          o.value = await a(e, t, s);
          break;
        default:
          throw new Error("Unknown prop dataSource value");
      }
    }
  };
}, I = (n) => n !== void 0 && n !== !1, lr = (n) => {
  var r, t;
  return (((t = (r = n.data) == null ? void 0 : r.staticClass) == null ? void 0 : t.split(" ")) ?? []).reduce(
    (s, o) => ({
      ...s,
      [o]: !0
    }),
    {}
  );
}, ar = (n) => {
  const e = {};
  return n.width && (e.width = n.width, e.minWidth = n.width, e.maxWidth = n.width), e;
}, cr = () => {
  const n = h([]);
  return { columns: n, initColumns: (r) => {
    const t = r.$scopedSlots.default, s = t ? t({}) : [];
    let o = 0;
    if (n.value = s.reduce((l, a) => {
      var C, w, b;
      if (!a.tag || !((C = a.componentOptions) != null && C.propsData))
        return l;
      const c = a.componentOptions.propsData, { field: u, title: _, orderable: m, searchable: v, width: y } = c, g = {
        index: o,
        params: {
          field: u,
          title: _ ?? null,
          orderable: I(m),
          searchable: I(v)
        },
        slots: {
          filter: (w = a.componentInstance) == null ? void 0 : w.$scopedSlots.filter,
          cell: (b = a.componentInstance) == null ? void 0 : b.$scopedSlots.cell
        },
        appearance: {
          classObject: lr(a),
          styleObject: ar({ width: y })
        }
      };
      return o += 1, [...l, g];
    }, []), !n.value.length)
      throw new Error("Columns not found");
  } };
}, ur = () => {
  const n = h(null);
  return {
    error: n,
    handleError: (t) => {
      throw t instanceof Error ? n.value = {
        message: t.message
      } : typeof t == "string" ? n.value = {
        message: t
      } : n.value = {
        message: "Unknown error"
      }, t;
    },
    clearError: () => {
      n.value = null;
    }
  };
}, ir = () => {
  const n = h(null);
  return {
    order: n,
    setOrder: (t) => {
      n.value = t;
    },
    resetOrder: () => {
      n.value = null;
    }
  };
}, dr = () => {
  const n = h(1), e = h(0);
  return {
    page: n,
    rowsPerPage: e,
    setPage: (s) => {
      n.value = s;
    },
    setRowsPerPage: (s) => {
      e.value = s;
    }
  };
}, pr = (n) => {
  const e = h([]), r = f(() => n.value ? n.value.rows.filter((c) => e.value.includes(c.index)) : []), t = f(() => n.value ? e.value.length === n.value.rows.length && !!e.value.length : !1);
  return {
    selectedRowIndexes: e,
    selectedRows: r,
    isSelectedAll: t,
    selectRow: (c) => {
      n.value && e.value.push(
        ...n.value.rows.filter((u) => u.index === c).map((u) => u.index)
      );
    },
    deselectRow: (c) => {
      n.value && (e.value = e.value.filter((u) => u !== c));
    },
    selectAll: () => {
      n.value && (e.value = n.value.rows.map((c) => c.index));
    },
    clearSelection: () => {
      e.value = [];
    }
  };
}, _r = () => {
  const n = h("");
  return {
    search: n,
    setSearch: (r) => {
      n.value = r;
    }
  };
}, fr = i({
  name: "DataTable",
  components: {
    TableRow: Ee,
    TableContent: re,
    TableFooter: ht,
    TableTop: Nt,
    TableSearch: Xt,
    TablePagination: qt,
    PageDetails: yt,
    RowsPerPageControl: Bt,
    TableBody: ae,
    TableHead: pt
  },
  props: Q,
  emits: ["update:selected-rows"],
  setup(n, { emit: e }) {
    const { dataSource: r, url: t, items: s, searching: o, pagination: l } = X(n), { error: a, handleError: c } = ur(), { columns: u, initColumns: _ } = cr(), { page: m, rowsPerPage: v, setPage: y, setRowsPerPage: g } = dr(), { search: C, setSearch: w } = _r(), { order: b, setOrder: x } = ir(), { tableData: k, fetchTableData: A } = or(r, t, s, u, {
      searching: o,
      search: C,
      pagination: l,
      rowsPerPage: v,
      page: m,
      order: b
    }), {
      selectedRowIndexes: L,
      selectedRows: O,
      isSelectedAll: F,
      selectRow: B,
      deselectRow: M,
      selectAll: E,
      clearSelection: P
    } = pr(k), D = async () => {
      try {
        J(n);
        const p = z();
        _(p.proxy), g(n.rowsPerPageCount), n.orderBy && x({
          column: n.orderBy,
          direction: n.orderDirection
        });
      } catch (p) {
        c(p);
      }
    }, j = (p) => {
      w(p), y(1), P();
    }, N = (p) => {
      g(p), y(1), P();
    }, H = (p) => {
      y(p), P();
    }, G = (p) => {
      x(p), P();
    }, Z = () => {
      E();
    }, U = () => {
      P();
    }, V = (p) => {
      B(p);
    }, W = (p) => {
      M(p);
    };
    return S(D), R(
      [() => C.value, () => v.value, () => m.value, () => b.value],
      T(async () => {
        try {
          await A();
        } catch (p) {
          c(p);
        }
      }, 200)
    ), R(
      () => O.value,
      T((p) => {
        e("update:selected-rows", p);
      }, 200)
    ), {
      error: a,
      search: C,
      page: m,
      rowsPerPage: v,
      order: b,
      columns: u,
      tableData: k,
      selectedRowIndexes: L,
      isSelectedAll: F,
      handleSearchInput: j,
      handleRowsPerPageInput: N,
      handlePageInput: H,
      handleOrderUpdate: G,
      handleSelectAll: Z,
      handleDeselectAll: U,
      handleSelectRow: V,
      handleDeselectRow: W
    };
  }
});
var vr = function() {
  var e = this, r = e._self._c;
  return e._self._setupProxy, r("div", [r("table-top", { scopedSlots: e._u([{ key: "topLeftBeforeActions", fn: function() {
    return [e._t("topLeftBeforeActions")];
  }, proxy: !0 }, { key: "topSearch", fn: function() {
    return [e.searching ? r("table-search", { attrs: { value: e.search }, on: { input: e.handleSearchInput } }) : e._e()];
  }, proxy: !0 }, { key: "topLeftAfterActions", fn: function() {
    return [e._t("topLeftAfterActions")];
  }, proxy: !0 }, { key: "topRight", fn: function() {
    return [e._t("topRight")];
  }, proxy: !0 }], null, !0) }), e.error ? r("div", [r("div", { staticClass: "data-table-error" }, [e._v(" " + e._s(e.error.message) + " ")])]) : r("table-content", { attrs: { "scroll-x": e.scrollX } }, [r("table-head", { attrs: { actions: e.actions, columns: e.columns, "fixed-columns-end": e.fixedColumnsEnd, "fixed-columns-start": e.fixedColumnsStart, "is-selected-all": e.isSelectedAll, numbering: e.numbering, order: e.order, "row-selection": e.rowSelection }, on: { "deselect-all": e.handleDeselectAll, "select-all": e.handleSelectAll, "update:order": e.handleOrderUpdate } }), e.tableData ? r("table-body", e._l(e.tableData.rows, function(t) {
    return r("table-row", { key: t.index, attrs: { actions: e.actions, columns: e.columns, "fixed-columns-end": e.fixedColumnsEnd, "fixed-columns-start": e.fixedColumnsStart, numbering: e.numbering, row: t, "row-selection": e.rowSelection, "selected-row-indexes": e.selectedRowIndexes }, on: { "deselect-row": e.handleDeselectRow, "select-row": e.handleSelectRow }, scopedSlots: e._u([{ key: "actions", fn: function() {
      return [e._t("actions", null, { row: t })];
    }, proxy: !0 }], null, !0) });
  }), 1) : e._e()], 1), r("table-footer", { scopedSlots: e._u([{ key: "footerLeft", fn: function() {
    return [e.pagination ? r("rows-per-page-control", { attrs: { "rows-per-page-options": e.rowsPerPageOptions, value: e.rowsPerPage }, on: { input: e.handleRowsPerPageInput } }) : e._e(), e.tableData ? r("page-details", { attrs: { "count-items": e.tableData.rows.length, filtered: e.tableData.filtered, page: e.page, "rows-per-page": e.rowsPerPage, total: e.tableData.total } }) : e._e()];
  }, proxy: !0 }, { key: "footerRight", fn: function() {
    return [e.tableData && e.pagination ? r("table-pagination", { attrs: { filtered: e.tableData.filtered, page: e.page, "rows-per-page": e.rowsPerPage }, on: { input: e.handlePageInput } }) : e._e()];
  }, proxy: !0 }]) }), e._t("default")], 2);
}, mr = [], hr = /* @__PURE__ */ d(
  fr,
  vr,
  mr
);
const xr = hr.exports, gr = /* @__PURE__ */ i({
  __name: "DataTableColumn",
  props: {
    field: {
      type: String,
      required: !0
    },
    title: {
      type: String,
      required: !1,
      default: null
    },
    orderable: {
      type: Boolean,
      default: !1
    },
    searchable: {
      type: Boolean,
      default: !1
    },
    width: {
      type: String,
      required: !1,
      default: null
    }
  },
  setup(n) {
    return { __sfc: !0, props: n, plug: {
      index: 1,
      number: 1,
      item: {}
    } };
  }
});
var Cr = function() {
  var e = this;
  return e._self._c, e._self._setupProxy, e._e();
}, wr = [], br = /* @__PURE__ */ d(
  gr,
  Cr,
  wr
);
const Pr = br.exports;
export {
  xr as DataTable,
  Pr as DataTableColumn
};
